package com.its.op.service.its.vms;

import com.its.op.dao.repository.its.vms.TbVmsIfscTrafRepository;
import com.its.op.dto.its.common.TrafDto;
import com.its.op.dto.its.vms.TbVmsIfscTrafDto;
import com.its.op.entity.its.vms.TbVmsIfscTraf;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsIfscTrafService {

    private final TbVmsIfscTrafRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVmsIfscTraf requireOne(Long id) throws NoSuchElementException {
        Optional<TbVmsIfscTraf> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVmsIfscTrafDto> findAll() {
        List<TbVmsIfscTrafDto> result = new ArrayList<>();
        List<TbVmsIfscTraf> data = this.repo.findAll();
        for (TbVmsIfscTraf entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVmsIfscTrafDto findById(Long id) {
        TbVmsIfscTraf entity = requireOne(id);
        return entity.toDto();
    }
    public TbVmsIfscTrafDto deleteById(Long id) {
        TbVmsIfscTraf entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    /**
     * 소통정보조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TrafDto> findAllTraf() {
        List<TrafDto> result = new ArrayList<>();
        List<TbVmsIfscTraf> data = this.repo.findAll();
        data.forEach(obj -> {
            result.add(obj.toTrafDto());
        });
        return result;
    }

    /**
     * VMS 제어기별 VMS 정보제공구간 소통정보 조회
     * @param id
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVmsIfscTrafDto> findAllTrafByVms(Long id) {
        List<TbVmsIfscTrafDto> result = new ArrayList<>();
        List<TbVmsIfscTraf> data = this.repo.findAllByVms(id);
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }

    public void deleteDataById(Long id) {
        this.repo.deleteDataById(id);
    }
}
